dg_Grid

	//==========================================================================
	proc
		/*
		//----------------------------------------------------------------------
		//	If On, this creates an entrance to SourceX,SourceY from cell EnteringX,EnteringY.
		//	Otherwise, such an entrance is removed.
		dg_SetEntranceCell(On=TRUE,SourceX,SourceY,EnteringX,EnteringY)
			//	Such a proc would be redundant.  All of the same input for SetExitCell().
		*/

		//----------------------------------------------------------------------
		//	If On, this creates an entrance to FromX,FromY from the cell in direction Dir.
		//	Otherwise, such an entrance is removed.
		dg_SetEntranceDir(On=TRUE,X,Y,Dir)
			var
				Xe	= src.grid2d_GetXInDir(X,Y,Dir,1)
				Ye	= src.grid2d_GetYInDir(X,Y,Dir,1)
			if (On)	return src.grid2d_PlaceItem(src.grid2d_GetItem(Xe,Ye) | src.grid2d_DirToDirBit(turn(Dir,180)), Xe, Ye)
			return src.grid2d_PlaceItem(src.grid2d_GetItem(Xe,Ye) & ~src.grid2d_DirToDirBit(turn(Dir,180)), Xe, Ye)

		//----------------------------------------------------------------------
		//	If On, this creates an exit for cell FromX,FromY to cell ToX,ToY.
		//	Otherwise, such an exit is removed.
		dg_SetExitCell(On=TRUE,FromX,FromY,ToX,ToY)
			//	The cells must be close, but neighbor bits are disregarded.
			//	The proc simply obeys.
			if ( !src.grid2d_HasCoordinates(FromX,FromY) )		return FALSE
			if ( !src.grid2d_HasCoordinates(ToX,ToY) )			return FALSE
			if (src.grid2d_GetDist(FromX,FromY,ToX,ToY) != 1)	return FALSE
			if (On)	return src.grid2d_PlaceItem( \
					src.grid2d_GetItem(FromX,FromY) | src.grid2d_DirToDirBit(src.grid2d_GetDir(FromX,FromY,ToX,ToY)), \
					FromX, FromY)
			return src.grid2d_PlaceItem( \
				src.grid2d_GetItem(FromX,FromY) & ~src.grid2d_DirToDirBit(src.grid2d_GetDir(FromX,FromY,ToX,ToY)), \
				FromX, FromY)

		//----------------------------------------------------------------------
		//	If On, this creates an exit for cell X,Y in direction Dir.
		//	Otherwise, such an exit is removed.
		dg_SetExitDir(On=TRUE,X,Y,Dir)
			if (On)	return src.grid2d_PlaceItem(src.grid2d_GetItem(X,Y) | src.grid2d_DirToDirBit(Dir), X, Y)
			return src.grid2d_PlaceItem(src.grid2d_GetItem(X,Y) & ~src.grid2d_DirToDirBit(Dir), X, Y)
