dg_Grid

	//==========================================================================
	proc
		//----------------------------------------------------------------------
		//	Returns a list of coordinates where every pair represents a dead end.
		dg_GetDeadEnds()
			.	= list()
			var
				X
				Y
			for(Y = 1 to src.grid2d_GetMaxY())
				for(X = 1 to src.grid2d_GetMaxX())
					if ( src.dg_IsDeadEnd(X,Y) )
						.	+= X
						.	+= Y

		//----------------------------------------------------------------------
		dg_IsDeadEnd(X,Y)
			if ( !src.grid2d_HasCoordinates(X,Y) )	return FALSE
			var/entrances	= src.dg_GetNumEntrances(X,Y)
			//	A dead end must have an entrance.
			if (entrances<1)	return FALSE
			//	A dead end with multiple entrances can't have exits.
			//	(That would make it a tunnel or funnel.)
			if (entrances>1)	return !src.dg_HasExits(X,Y)
			//	There can be a single exit if it is also the lone entrance.
			var/list/exits		= src.dg_GetExits(X,Y)
			if (exits.len==2)	return src.dg_IsEnteredByCell(X,Y,exits[1],exits[2])
			return !exits.len

