dg_Grid

	//==========================================================================
	proc
		//----------------------------------------------------------------------
		//	If Entered is entered by Target (directly or indirectly), this
		//	returns the minimum number of entrances between them.
		//	Returns -1 on failure.
		dg_GetEntranceDistance(TargetX,TargetY,EnteredX,EnteredY)
			if ( !src.grid2d_HasCoordinates(TargetX,TargetY) )		return -1
			if ( !src.grid2d_HasCoordinates(EnteredX,EnteredY) )	return -1
			if ( (EnteredX==TargetX) && (EnteredY==TargetY) )		return 0
			if ( src.dg_IsIsolated(EnteredX,EnteredY) )				return -1
			var
				distance	= 0
				list/coords	= src.dg_GetEntrances(TargetX,TargetY)//	ENTRANCES
				index
				start	= 1
				end		= coords.len/2
				storage
				list/checked	= list()
			checked.len			= src.grid2d_cells.len
			while(start<=end)
				distance++
				for(index = start to end)
					//	Set the distance of unset coordinates.
					storage	= src.grid2d_XYToIndex(coords[2*index-1],coords[2*index])
					if (!storage || checked[storage])	continue
					checked[storage]					= TRUE
					//	Find it?
					if ( (coords[2*index-1]==EnteredX) && (coords[2*index]==EnteredY) )
						return distance
					//	Gather new exit coordinates.
					coords	+= src.dg_GetEntrances(coords[2*index-1],coords[2*index])//	ENTRANCES
				//	Prepare to test the new coordinates.
				start	= end+1
				end		= coords.len/2
			//	They must not be connected.
			return -1

		//----------------------------------------------------------------------
		//	If Exited exits to Target (directly or indirectly), this returns the
		//	minimum number of exits between them.  Returns -1 on failure.
		dg_GetExitDistance(ExitedX,ExitedY,TargetX,TargetY)
			if ( !src.grid2d_HasCoordinates(ExitedX,ExitedY) )	return -1
			if ( !src.grid2d_HasCoordinates(TargetX,TargetY) )	return -1
			if ( (ExitedX==TargetX) && (ExitedY==TargetY) )		return 0
			if ( src.dg_IsIsolated(TargetX,TargetY) )			return -1
			var
				distance	= 0
				list/coords	= src.dg_GetExits(ExitedX,ExitedY)//	EXITS
				index
				start	= 1
				end		= coords.len/2
				storage
				list/checked	= list()
			checked.len			= src.grid2d_cells.len
			while(start<=end)
				distance++
				for(index = start to end)
					//	Set the distance of unset coordinates.
					storage	= src.grid2d_XYToIndex(coords[2*index-1],coords[2*index])
					if (!storage || checked[storage])	continue
					checked[storage]					= TRUE
					//	Find it?
					if ( (coords[2*index-1]==TargetX) && (coords[2*index]==TargetY) )
						return distance
					//	Gather new exit coordinates.
					coords	+= src.dg_GetExits(coords[2*index-1],coords[2*index])//	EXITS
				//	Prepare to test the new coordinates.
				start	= end+1
				end		= coords.len/2
			//	They must not be connected.
			return -1
