dg_Grid

	//==========================================================================
	proc
		//----------------------------------------------------------------------
		//	Returns a list of directions from the cell at X,Y to each neighboring
		//	cell that enters it.
		dg_GetEntranceDirs(X,Y)
			if ( !isnum(X) || !isnum(Y) )						return list()
			.													= list()
			if (src.grid2d_SOUTH&src.grid2d_GetItem(X,Y+1))			.	+= NORTH
			if (src.grid2d_SOUTHWEST&src.grid2d_GetItem(X+1,Y+1))	.	+= NORTHEAST
			if (src.grid2d_WEST&src.grid2d_GetItem(X+1,Y))			.	+= EAST
			if (src.grid2d_NORTHWEST&src.grid2d_GetItem(X+1,Y-1))	.	+= SOUTHEAST
			if (src.grid2d_NORTH&src.grid2d_GetItem(X,Y-1))			.	+= SOUTH
			if (src.grid2d_NORTHEAST&src.grid2d_GetItem(X-1,Y-1))	.	+= SOUTHWEST
			if (src.grid2d_EAST&src.grid2d_GetItem(X-1,Y))			.	+= WEST
			if (src.grid2d_SOUTHEAST&src.grid2d_GetItem(X-1,Y+1))	.	+= NORTHWEST

		//----------------------------------------------------------------------
		//	Returns a list of coordinates of cells with entrances to cell X,Y.
		dg_GetEntrances(X,Y)
			if ( !isnum(X) || !isnum(Y) )	return list()
			.		= list()
			if (src.grid2d_SOUTH&src.grid2d_GetItem(X,Y+1))
				.	+= X
				.	+= Y+1
			if (src.grid2d_SOUTHWEST&src.grid2d_GetItem(X+1,Y+1))
				.	+= X+1
				.	+= Y+1
			if (src.grid2d_WEST&src.grid2d_GetItem(X+1,Y))
				.	+= X+1
				.	+= Y
			if (src.grid2d_NORTHWEST&src.grid2d_GetItem(X+1,Y-1))
				.	+= X+1
				.	+= Y-1
			if (src.grid2d_NORTH&src.grid2d_GetItem(X,Y-1))
				.	+= X
				.	+= Y-1
			if (src.grid2d_NORTHEAST&src.grid2d_GetItem(X-1,Y-1))
				.	+= X-1
				.	+= Y-1
			if (src.grid2d_EAST&src.grid2d_GetItem(X-1,Y))
				.	+= X-1
				.	+= Y
			if (src.grid2d_SOUTHEAST&src.grid2d_GetItem(X-1,Y+1))
				.	+= X-1
				.	+= Y+1
			var
				list/results
				index
			if ( src.grid2d_DoesWrapX() )
				results	= .
				index	= length(results)/2
				while(index>0)
					results[2*index-1]	= src.grid2d_GetWrapX(results[2*index-1])
					index--
			if ( src.grid2d_DoesWrapY() )
				results	= .
				index	= length(results)/2
				while(index>0)
					results[2*index]	= src.grid2d_GetWrapY(results[2*index])
					index--

		//----------------------------------------------------------------------
		//	Returns a list of directional bits representing the direction from
		//	the cell at X,Y to each neighboring cell that enters it.
		dg_GetEntranceDirBits(X,Y)
			if ( !isnum(X) || !isnum(Y) )						return list()
			.													= list()
			if (src.grid2d_SOUTH&src.grid2d_GetItem(X,Y+1))			.	+= src.grid2d_NORTH
			if (src.grid2d_SOUTHWEST&src.grid2d_GetItem(X+1,Y+1))	.	+= src.grid2d_NORTHEAST
			if (src.grid2d_WEST&src.grid2d_GetItem(X+1,Y))			.	+= src.grid2d_EAST
			if (src.grid2d_NORTHWEST&src.grid2d_GetItem(X+1,Y-1))	.	+= src.grid2d_SOUTHEAST
			if (src.grid2d_NORTH&src.grid2d_GetItem(X,Y-1))			.	+= src.grid2d_SOUTH
			if (src.grid2d_NORTHEAST&src.grid2d_GetItem(X-1,Y-1))	.	+= src.grid2d_SOUTHWEST
			if (src.grid2d_EAST&src.grid2d_GetItem(X-1,Y))			.	+= src.grid2d_WEST
			if (src.grid2d_SOUTHEAST&src.grid2d_GetItem(X-1,Y+1))	.	+= src.grid2d_NORTHWEST


		//----------------------------------------------------------------------
		//	Returns how many neighboring cells enter into the cell at X,Y.
		dg_GetNumEntrances(X,Y)
			if ( !isnum(X) || !isnum(Y) )						return 0
			.													= 0
			if (src.grid2d_SOUTH&src.grid2d_GetItem(X,Y+1))			.	+= 1
			if (src.grid2d_SOUTHWEST&src.grid2d_GetItem(X+1,Y+1))	.	+= 1
			if (src.grid2d_WEST&src.grid2d_GetItem(X+1,Y))			.	+= 1
			if (src.grid2d_NORTHWEST&src.grid2d_GetItem(X+1,Y-1))	.	+= 1
			if (src.grid2d_NORTH&src.grid2d_GetItem(X,Y-1))			.	+= 1
			if (src.grid2d_NORTHEAST&src.grid2d_GetItem(X-1,Y-1))	.	+= 1
			if (src.grid2d_EAST&src.grid2d_GetItem(X-1,Y))			.	+= 1
			if (src.grid2d_SOUTHEAST&src.grid2d_GetItem(X-1,Y+1))	.	+= 1

		//----------------------------------------------------------------------
		//	Returns whether or not the cell has any entrances at all.
		dg_HasEntrances(X,Y)
			if ( !isnum(X) || !isnum(Y) )						return FALSE
			if (src.grid2d_SOUTH&src.grid2d_GetItem(X,Y+1))			return TRUE
			if (src.grid2d_SOUTHWEST&src.grid2d_GetItem(X+1,Y+1))	return TRUE
			if (src.grid2d_WEST&src.grid2d_GetItem(X+1,Y))			return TRUE
			if (src.grid2d_NORTHWEST&src.grid2d_GetItem(X+1,Y-1))	return TRUE
			if (src.grid2d_NORTH&src.grid2d_GetItem(X,Y-1))			return TRUE
			if (src.grid2d_NORTHEAST&src.grid2d_GetItem(X-1,Y-1))	return TRUE
			if (src.grid2d_EAST&src.grid2d_GetItem(X-1,Y))			return TRUE
			if (src.grid2d_SOUTHEAST&src.grid2d_GetItem(X-1,Y+1))	return TRUE
			return FALSE

		//----------------------------------------------------------------------
		//	Returns whether or not the cell at FromX,FromY is entered by the cell at ToX,ToY.
		dg_IsEnteredByCell(FromX,FromY,ToX,ToY)
			//	They must be neighbors.
			if ( !src.grid2d_AreNeighbors(FromX,FromY,ToX,ToY) )	return FALSE
			//	There must be an exit in that direction.
			return src.grid2d_GetItem(ToX,ToY) & src.grid2d_DirToDirBit(src.grid2d_GetDir(ToX,ToY,FromX,FromY))

		//----------------------------------------------------------------------
		//	Returns whether or not the cell in direction Dir of X,Y enters X,Y.
		//	Ex: Does the cell to the north have a southern exit?
		dg_IsEnteredByDir(X,Y,Dir)
			return src.grid2d_GetItem(src.grid2d_GetXInDir(X,Y,Dir,1),src.grid2d_GetYInDir(X,Y,Dir,1)) & src.grid2d_DirToDirBit(turn(Dir,180))
