dg_Grid

	//==========================================================================
	proc
		//----------------------------------------------------------------------
		//	Returns whether or not the cell at FromX,FromY exits into the cell at ToX,ToY.
		dg_DoesExitToCell(FromX,FromY,ToX,ToY)
			//	They must be neighbors.
			if ( !src.grid2d_AreNeighbors(FromX,FromY,ToX,ToY) )	return FALSE
			//	There must be an exit in that direction.
			return src.grid2d_GetItem(FromX,FromY) & src.grid2d_DirToDirBit(src.grid2d_GetDir(FromX,FromY,ToX,ToY))

		//----------------------------------------------------------------------
		//	Returns whether or not the cell at X,Y has an exit in direction Dir.
		dg_DoesExitToDir(X,Y,Dir)
			return src.grid2d_GetItem(X,Y) & src.grid2d_DirToDirBit(Dir)

		//----------------------------------------------------------------------
		//	Returns a list of the directions exiting from the cell at X,Y.
		dg_GetExitDirs(X,Y)
			return src.grid2d_BitsToDirList( src.grid2d_GetItem(X,Y) )

		//----------------------------------------------------------------------
		//	Returns a list of coordinates where the exits of cell X,Y lead to.
		dg_GetExits(X,Y)
			.			= list()
			var/bits	= src.grid2d_GetItem(X,Y)
			if(bits&src.grid2d_NORTH)
				.	+= src.grid2d_GetXInDir(X,Y,NORTH,1)
				.	+= src.grid2d_GetYInDir(X,Y,NORTH,1)
			if(bits&src.grid2d_NORTHEAST)
				.	+= src.grid2d_GetXInDir(X,Y,NORTHEAST,1)
				.	+= src.grid2d_GetYInDir(X,Y,NORTHEAST,1)
			if(bits&src.grid2d_EAST)
				.	+= src.grid2d_GetXInDir(X,Y,EAST,1)
				.	+= src.grid2d_GetYInDir(X,Y,EAST,1)
			if(bits&src.grid2d_SOUTHEAST)
				.	+= src.grid2d_GetXInDir(X,Y,SOUTHEAST,1)
				.	+= src.grid2d_GetYInDir(X,Y,SOUTHEAST,1)
			if(bits&src.grid2d_SOUTH)
				.	+= src.grid2d_GetXInDir(X,Y,SOUTH,1)
				.	+= src.grid2d_GetYInDir(X,Y,SOUTH,1)
			if(bits&src.grid2d_SOUTHWEST)
				.	+= src.grid2d_GetXInDir(X,Y,SOUTHWEST,1)
				.	+= src.grid2d_GetYInDir(X,Y,SOUTHWEST,1)
			if(bits&src.grid2d_WEST)
				.	+= src.grid2d_GetXInDir(X,Y,WEST,1)
				.	+= src.grid2d_GetYInDir(X,Y,WEST,1)
			if(bits&src.grid2d_NORTHWEST)
				.	+= src.grid2d_GetXInDir(X,Y,NORTHWEST,1)
				.	+= src.grid2d_GetYInDir(X,Y,NORTHWEST,1)
			var
				list/results
				index
			if ( src.grid2d_DoesWrapX() )
				results	= .
				index	= length(results)/2
				while(index>0)
					results[2*index-1]	= src.grid2d_GetWrapX(results[2*index-1])
					index--
			if ( src.grid2d_DoesWrapY() )
				results	= .
				index	= length(results)/2
				while(index>0)
					results[2*index]	= src.grid2d_GetWrapY(results[2*index])
					index--

		//----------------------------------------------------------------------
		//	Returns a list of the directional bits exiting from the cell at X,Y.
		dg_GetExitDirBits(X,Y)
			return src.grid2d_BitsToDirBitList( src.grid2d_GetItem(X,Y) )

		//----------------------------------------------------------------------
		//	Returns how many exits the cell at X,Y has.
		dg_GetNumExits(X,Y)
			return src.grid2d_GetNumDirBits( src.grid2d_GetItem(X,Y) )

		//----------------------------------------------------------------------
		//	Returns whether or not the cell has any exits at all.
		dg_HasExits(X,Y)
			return (src.grid2d_GetItem(X,Y) != src.grid2d_NONE)
