dg_Grid

	//==========================================================================
	proc
		//	A fork has multiple exits and at least one entrance.

		//----------------------------------------------------------------------
		//	Returns a list of coordinates where every pair represents a fork.
		dg_GetForks()
			.	= list()
			var
				X
				Y
			for(Y = 1 to src.grid2d_GetMaxY())
				for(X = 1 to src.grid2d_GetMaxX())
					if ( src.dg_IsFork(X,Y) )
						.	+= X
						.	+= Y

		//----------------------------------------------------------------------
		//	Returns TRUE if the cell X,Y is a fork.
		dg_IsFork(X,Y)
			//	A fork has at least one entrance.
			if ( !src.dg_HasEntrances(X,Y) )	return FALSE
			//	A fork must have at least 2 exits.
			var/list/exits		= src.dg_GetExits(X,Y)
			if (exits.len<4)	return FALSE
			//	Anything with more than 2 exits qualifies.
			if (exits.len>4)	return TRUE
			//	However, an exit doubling as an entrance would make it a tunnel.
			if ( src.dg_IsEnteredByCell(X,Y,exits[1],exits[2]) )	return FALSE
			if ( src.dg_IsEnteredByCell(X,Y,exits[3],exits[4]) )	return FALSE
			return TRUE
