dg_Grid

	//==========================================================================
	proc
		//	A funnel has multiple entrances and at least one exit.

		//----------------------------------------------------------------------
		//	Returns a list of coordinates where every pair represents a funnel.
		dg_GetFunnels()
			.	= list()
			var
				X
				Y
			for(Y = 1 to src.grid2d_GetMaxY())
				for(X = 1 to src.grid2d_GetMaxX())
					if ( src.dg_IsFunnel(X,Y) )
						.	+= X
						.	+= Y

		//----------------------------------------------------------------------
		//	Returns TRUE if the cell X,Y is a funnel.
		dg_IsFunnel(X,Y)
			//	A funnel has at least one exit.
			if ( !src.dg_HasExits(X,Y) )	return FALSE
			//	A funnel must have at least two entrances.
			var/list/entrances		= src.dg_GetEntrances(X,Y)
			if (entrances.len<4)	return FALSE
			//	Anything with more than 2 entrances qualifies.
			if (entrances.len>4)	return TRUE
			//	However, an entrance doubling as an exit would make it a tunnel.
			if ( src.dg_DoesExitToCell(X,Y,entrances[1],entrances[2]) )	return FALSE
			if ( src.dg_DoesExitToCell(X,Y,entrances[3],entrances[4]) )	return FALSE
			return TRUE
