dg_Grid

	//==========================================================================
	proc
		//----------------------------------------------------------------------
		//	Returns a list of coordinates where every pair represents an isolated cell.
		dg_GetIsolatedCells()
			.	= list()
			var
				X
				Y
			for(Y = 1 to src.grid2d_GetMaxY())
				for(X = 1 to src.grid2d_GetMaxX())
					if ( src.dg_IsIsolated(X,Y) )
						.	+= X
						.	+= Y

		//----------------------------------------------------------------------
		//	Returns TRUE if cell X,Y has no connections in or out.
		dg_IsIsolated(X,Y)
			return ( src.grid2d_HasCoordinates(X,Y) && !src.dg_HasExits(X,Y) && !src.dg_HasEntrances(X,Y) )

		//----------------------------------------------------------------------
		//	Removes all connections coming in and out of cell X,Y.
		//	Returns TRUE if the event occured.
		dg_Isolate(X,Y)
			.	= FALSE
			if ( src.dg_HasExits(X,Y) )
				src.grid2d_PlaceItem(src.grid2d_NONE,X,Y)
				.	= TRUE
			if ( src.dg_HasEntrances(X,Y) )
				src.dg_SetEntranceDir(FALSE,X,Y,NORTH)
				src.dg_SetEntranceDir(FALSE,X,Y,NORTHEAST)
				src.dg_SetEntranceDir(FALSE,X,Y,EAST)
				src.dg_SetEntranceDir(FALSE,X,Y,SOUTHEAST)
				src.dg_SetEntranceDir(FALSE,X,Y,SOUTH)
				src.dg_SetEntranceDir(FALSE,X,Y,SOUTHWEST)
				src.dg_SetEntranceDir(FALSE,X,Y,WEST)
				src.dg_SetEntranceDir(FALSE,X,Y,NORTHWEST)
				.	= TRUE
