dg_Grid

	//==========================================================================
	proc
		//----------------------------------------------------------------------
		//	Returns a list of coordinates where every pair represents an origin.
		dg_GetOrigins()
			.	= list()
			var
				X
				Y
			for(Y = 1 to src.grid2d_GetMaxY())
				for(X = 1 to src.grid2d_GetMaxX())
					if ( src.dg_IsOrigin(X,Y) )
						.	+= X
						.	+= Y

		//----------------------------------------------------------------------
		//	Returns TRUE if Node is an origin.
		dg_IsOrigin(X,Y)
			var/exits		= src.dg_GetNumExits(X,Y)
			//	An origin must have an exit.
			if (exits<1)	return FALSE
			//	An origin with multiple exits can't have entrances.
			//	(That would make it a tunnel or fork.)
			if (exits>1)	return !src.dg_HasEntrances(X,Y)
			//	There can be a single entrance if it is also the lone exit.
			var/list/entrances	= src.dg_GetEntrances(X,Y)
			if (entrances.len==2) return src.dg_DoesExitToCell(X,Y,entrances[1],entrances[2])
			return !entrances.len
