dg_Grid

	//==========================================================================
	proc
		//	A tunnel allows travel between two nodes in at least one direction.

		//----------------------------------------------------------------------
		dg_GetTunnels()
			.	= list()
			var
				X
				Y
			for(Y = 1 to src.grid2d_GetMaxY())
				for(X = 1 to src.grid2d_GetMaxX())
					if ( src.dg_IsTunnel(X,Y) )
						.	+= X
						.	+= Y

		//----------------------------------------------------------------------
		dg_IsTunnel(X,Y)
			if ( !src.grid2d_HasCoordinates(X,Y) )	return FALSE
			var
				list/exits		= src.dg_GetExits(X,Y)
				list/entrances	= src.dg_GetEntrances(X,Y)
			//	It may have a single exit.
			if (exits.len==2)
				//	It may have 2 entrances if one is the exit.
				if (entrances.len==4)
					if ((exits[1]==entrances[1]) && (exits[2]==entrances[2]))	return TRUE
					if ((exits[1]==entrances[3]) && (exits[2]==entrances[4]))	return TRUE
					return FALSE
				//	Otherwise, it must have a lone entrance which is NOT the exit.
				if (entrances.len==2)	return !((exits[1]==entrances[1]) && (exits[2]==entrances[2]))
				return FALSE
			//	It may have two exits.
			if (exits.len==4)
				//	It may have 2 entrances if they are the exits. (It might reciprocate.)
				if (entrances.len==4)
					if ((exits[1]==entrances[1]) && (exits[2]==entrances[2]))
						return ((exits[3]==entrances[3]) && (exits[4]==entrances[4]))
					if ((exits[1]==entrances[3]) && (exits[2]==entrances[4]))
						return ((exits[3]==entrances[1]) && (exits[4]==entrances[2]))
				//	Otherwise, it MUST have a lone entrance as an exit.
				if (entrances.len==2)
					if ((exits[1]==entrances[1]) && (exits[2]==entrances[2]))	return TRUE
					if ((exits[3]==entrances[1]) && (exits[4]==entrances[2]))	return TRUE
			return FALSE
